/*
* senior remote control
*
* sen-fb.h
*
*
* Author:	GEKU
*
*   Version 3.0
*/


#ifndef SEN_FB_SEN_FB_H_
#define SEN_FB_SEN_FB_H_

   // PORT 1
    #define prog1   BIT0    // P1.0 0x01 input, internal pull up
    #define prog2   BIT1    // P1.1 0x02 input, internal pull up
    #define prog3   BIT2    // P1.2 0x04 input, internal pull up
    #define prog4   BIT3    // P1.3 0x08 input, internal pull up
    #define prog5   BIT4    // P1.4 0x10 input, internal pull up
    #define prog6   BIT5    // P1.5 0x20 input, internal pull up
    #define prog7   BIT6    // P1.6 0x40 input, internal pull up
    #define prog8   BIT7    // P1.7 0x80 input, internal pull up

    // PORT 2
    #define prog9   BIT0    // P2.0 0x01 input, internal pull up
    #define prog_up BIT1    // P2.1 0x02 input, internal pull up
    #define prog_dn BIT2    // P2.2 0x04 input, internal pull up
    #define soften  BIT3    // P2.3 0x08 input, internal pull up
    #define louder  BIT4    // P2.4 0x10 input, internal pull up
    #define ir_in   BIT5    // P2.5 0x20 input, external pull up
    #define on_off  BIT6    // P2.6 0x40 input, internal pull up
    #define ir_out  BIT7    // P2.7 0x80 output

    #define PU_PD   (PROG_UP+PROG_DN)   //  0: CE00 - CFFF
    #define PROG1   0x0001              //  1: D000 - D1FF
    #define PROG2   0x0002              //  2: D200 - D3FF
    #define PROG3   0x0004              //  3: D400 - D5FF
    #define PROG4   0x0008              //  4: D600 - D7FF
    #define PROG5   0x0010              //  5: D800 - D9FF
    #define PROG6   0x0020              //  6: DA00 - DBFF
    #define PROG7   0x0040              //  7: DC00 - DDFF
    #define PROG8   0x0080              //  8: DE00 - DFFF
    #define PROG9   0x0100              //  9: E000 - E1FF
    #define PROG10  (PROG1+PROG2)       // 10: E200 - E3FF
    #define PROG11  (PROG2+PROG3)       // 11: E400 - E5FF
    #define PROG12  (PROG3+PROG4)       // 12: E600 - E7FF
    #define PROG13  (PROG4+PROG5)       // 13: E800 - E9FF
    #define PROG14  (PROG5+PROG6)       // 14: EA00 - EBFF
    #define PROG15  (PROG6+PROG7)       // 15: EC00 - EDFF
    #define PROG16  (PROG7+PROG8)       // 16: EE00 - EFFF
    #define PROG17  (PROG8+PROG9)       // 17: F000 - F1FF

    #define L_S     (LOUDER+SOFTEN)     // 18: F200 - F2FF
    #define PROG_UP 0x0200              // 19: F300 - F3FF
    #define PROG_DN 0x0400              // 20: F400 - F4FF
    #define SOFTEN  0x0800              // 21: F500 - F5FF
    #define LOUDER  0x1000              // 22: F600 - F6FF
    #define ON_OFF  0x4000              // 23: F700 - F7FF
	#define PU_PROG1	PROG_UP+PROG1	// 24: F800 - F9FF
	#define PU_PROG2	PROG_UP+PROG2	// 25: FA00 - FBFF
	#define PU_PROG3	PROG_UP+PROG3	// 26: FC00 - FDFF
	
    // interrupt vector table                  FE00 - FFFF
    #define CLEAR_PROG      (PROG_UP+PROG_DN)
    #define CLEAR_ENABLE    (PROG_UP+ON_OFF)
    #define CLEAR_DISABLE   (PROG_DN+ON_OFF)


    #define buttons_p1  (prog1|prog2|prog3|prog4|prog5|prog6|prog7|prog8)
    #define buttons_p2  (prog9|louder|soften|prog_up|prog_dn|on_off)
    #define BUTTONS_P1  (PROG1|PROG2|PROG3|PROG3|PROG5|PROG6|PROG7|PROG8)
    #define BUTTONS_P2  (PROG9|LOUDER|SOFTEN|PROG_UP|PROG_DN|ON_OFF)
    #define BUTTONS (BUTTON_P1|BUTTON_P1)

    #define IRC_BUFFER  0xF800
    #define IRC_TABLE	0x1040
    #define MAX_BREAK  	6000
	
	#define FIRST_BIG_TIME	0xF0
	#define LAST_BIG_TIME	0xFE
	#define T250MS			62500
	
#endif /* SEN_FB_SEN_FB_H_ */
